#ifdef APPRNPAPI_EXPORTS
#define APPRNPAPI __declspec(dllexport)
#else
#define APPRNPAPI __declspec(dllimport)
#endif


typedef int (CALLBACK *fnStatusCallbackFunc)(int nStatus);

APPRNPAPI long __stdcall PrinterOpen(int nInterface, 
									LPCSTR szPortName	= "", 
									int nBaudRate		= CBR_115200, // Socket (Ethernet/WiFi) : Port Number, Serial : BaudRate
									int nDataBits		= DATABITS_8, 
									int nParity			= NOPARITY, 
									int nStopBits		= ONESTOPBIT);
APPRNPAPI long __stdcall PrinterOpenW(int nInterface, 
								   LPCWSTR szPortName	= L"", 
								   int nBaudRate		= CBR_115200, // Socket (Ethernet/WiFi) : Port Number, Serial : BaudRate
								   int nDataBits		= DATABITS_8, 
								   int nParity			= NOPARITY, 
								   int nStopBits		= ONESTOPBIT);

APPRNPAPI long __stdcall PrinterClose();

APPRNPAPI long __stdcall InitializePrinter();
APPRNPAPI long __stdcall GetPrinterCurrentStatus();
APPRNPAPI long __stdcall PrintText(LPCSTR Data, long Alignment, long Attribute, long TextSize);
APPRNPAPI long __stdcall PrintTextW(LPCWSTR Data, long Alignment, long Attribute, long TextSize, long lCodePage = CP_ACP);
APPRNPAPI long __stdcall PrintTextInImage(LPCSTR Data, LPCSTR FontName, BOOL Italic, BOOL Bold, BOOL Underline, int FontSize, int Alignment);
APPRNPAPI long __stdcall PrintTextInImageW(LPCWSTR Data, LPCWSTR FontName, BOOL Italic, BOOL Bold, BOOL Underline, int FontSize, int Alignment);
APPRNPAPI long __stdcall LineFeed(int nFeed);
APPRNPAPI long __stdcall PrintBitmap(LPCSTR FileName, long Width, long Alignment, long Level, BOOL bDithering);
APPRNPAPI long __stdcall PrintBitmapW(LPCWSTR FileName, long Width, long Alignment, long Level, BOOL bDithering);
APPRNPAPI long __stdcall GetPrintBitmapBuf(LPCSTR fileName, long Width, long Level, BOOL bDithering, PBYTE pOutBuffer, DWORD cbBuf, LPDWORD pcbNeeded);
APPRNPAPI long __stdcall GetPrintBitmapBufW(LPCWSTR fileName, long Width, long Level, BOOL bDithering, PBYTE pOutBuffer, DWORD cbBuf, LPDWORD pcbNeeded);
APPRNPAPI long __stdcall PrintBarcode(PCHAR Data, long Symbology, long Height, long Width, long Alignment, long TextPosition);
APPRNPAPI long __stdcall PrintQRCode(PCHAR Data, long model, long moduleSize, long eccLevel, long alignment);
APPRNPAPI long __stdcall PrintPDF417(PCHAR data, long type, long columnNumber, long rowNumber, long moduleWidth, long moduleHeight, long eccLevel, long alignment);
APPRNPAPI long __stdcall PrintDataMatrix(PCHAR data, long moduleSize, long alignment);
APPRNPAPI long __stdcall SetCharacterSet(long Value);
APPRNPAPI long __stdcall SetInterChrSet(long Value);
APPRNPAPI long __stdcall GetCharacterSet();
APPRNPAPI long __stdcall GetInterChrSet();	
APPRNPAPI long __stdcall SetUpsideDown(long mode);
APPRNPAPI long __stdcall SetLeftMargin(long margin);
APPRNPAPI long __stdcall SetPrintWidth(long width);
APPRNPAPI long __stdcall CutPaper();
APPRNPAPI long __stdcall DirectIO(PCHAR Data, UINT uiWrite, PCHAR pRequest, UINT& uiRead);
APPRNPAPI long __stdcall WriteBuff(PBYTE pBuffer, long lNumberOfBytesToWrite, long& lWritten);
APPRNPAPI long __stdcall ReadBuff(PBYTE pBuffer, long lNumberOfBytesToRead, long& lReaded);

APPRNPAPI long __stdcall OpenDrawer(long pinNumber);
APPRNPAPI long __stdcall SetPagemode(long pageMode);
APPRNPAPI long __stdcall SetPagemodePrintArea(long x, long y, long width, long height);
APPRNPAPI long __stdcall SetPagemodeDirection(long direction);
APPRNPAPI long __stdcall SetPagemodePosition(long x, long y);
// Provides notification regarding the call of the callback function notifying the application when printer's status changes.
APPRNPAPI long __stdcall BidiSetCallBack(fnStatusCallbackFunc pStatusCallbackFn);
APPRNPAPI long __stdcall BidiCancelCallBack();

APPRNPAPI long __stdcall TransactionStart();
APPRNPAPI long __stdcall TransactionEnd(BOOL SendCompletedCheck, long Timeout);

