
// PAGE MODE
#define _PRINTER_PD_0			0
#define _PRINTER_PD_LEFT90		1
#define _PRINTER_PD_180			2
#define _PRINTER_PD_RIGHT90		3

#define _PRINTER_PAGEMODE_OUT	0
#define _PRINTER_PAGEMODE_IN	1

// CASH DRAWER
#define _CASHDRAWER_PIN2		0
#define _CASHDRAWER_PIN5		1

// BCD TEXT ENCODING
#define _TEXT_ENCODE_PC437  437
#define _TEXT_ENCODE_PC866  866
#define _TEXT_ENCODE_PC852  852
#define _TEXT_ENCODE_PC857  857

//Result Code 
#define _SUCCESS				0
#define _READBUFFER_EMPTY		-1
#define _CANNOT_OPEN			-100
#define _NOT_OPENED				-101
#define _CREATE_ERROR			-102
#define _CONNECT_ERROR			-105
#define _NOT_SUPPORT			-107
#define _BAD_ARGUMENT			-108 
#define _BUFFER_ERROR			-109 
#define _TEXT_ENCODING_ERROR	-120 
#define _PAGE_MODE_ALREADY_IN	-130
#define _NOT_IN_PAGE_MODE		-131
#define _REGISTRY_ERROR			-200
#define _WRITE_ERROR			-300
#define _READ_ERROR				-301
#define _BITMAPLOAD_ERROR		-400
#define _BITMAPDATA_ERROR		-401
#define _BC_DATA_ERROR			-500
#define _BC_NOT_SUPPORT			-501

// Printer Status
#define _STS_NORMAL					0
#define _STS_PAPEREMPTY				1
#define _STS_COVEROPEN				2
#define _STS_CASHDRAWER_HIGH		16
#define _STS_ERROR					32
#define _STS_CASHDRAWER_LOW			512

//Alignment
#define _ALIGNMENT_LEFT			0
#define _ALIGNMENT_CENTER		1
#define _ALIGNMENT_RIGHT		2

//Text Attribute
#define _FT_DEFAULT			0
#define _FT_FONTB			1
#define _FT_FONTC			16 
#define _FT_BOLD			2
#define _FT_UNDERLINE		4		
#define _FT_UNDERTHICK		6
#define _FT_REVERSE			8
#define _FT_UPSIDEDOWN		10

//Text Size Attribute
#define _TS_0WIDTH			0
#define _TS_1WIDTH			16
#define _TS_2WIDTH			32
#define _TS_3WIDTH			48
#define _TS_4WIDTH			64
#define _TS_5WIDTH			80
#define _TS_6WIDTH			96
#define _TS_7WIDTH			112

#define _TS_0HEIGHT			0	
#define _TS_1HEIGHT			1
#define _TS_2HEIGHT			2
#define _TS_3HEIGHT			3
#define _TS_4HEIGHT			4
#define _TS_5HEIGHT			5
#define _TS_6HEIGHT			6
#define _TS_7HEIGHT			7

//Width Full
#define _WIDTH_FULL	-1
#define _WIDTH_NONE	-2

// QR CODE MODEL
#define _QRCODE_MODEL1			49
#define _QRCODE_MODEL2			50
// QR CODE ECC LEVEL
#define _QRCODE_ECC_LEVEL_L		48
#define _QRCODE_ECC_LEVEL_M		49
#define _QRCODE_ECC_LEVEL_Q		50
#define _QRCODE_ECC_LEVEL_H		51
// PDF417 TYPE
#define _PDF417_TYPE1			49
#define _PDF417_TYPE2			50
// PDF417 ECC LEVEL
#define _PDF417_ECC_LEVEL_0		48
#define _PDF417_ECC_LEVEL_1		49
#define _PDF417_ECC_LEVEL_2		50
#define _PDF417_ECC_LEVEL_3		51
#define _PDF417_ECC_LEVEL_4		52
#define _PDF417_ECC_LEVEL_5		53
#define _PDF417_ECC_LEVEL_6		54
#define _PDF417_ECC_LEVEL_7		55
#define _PDF417_ECC_LEVEL_8		56

// BARCODE
#define _BCS_UPCA				101
#define _BCS_UPCE				102
#define _BCS_EAN8				103
#define _BCS_EAN13				104
#define _BCS_JAN8				105
#define _BCS_JAN13				106
#define _BCS_ITF				107
#define _BCS_CODABAR			108
#define _BCS_CODE39				109
#define _BCS_CODE93				110
#define _BCS_CODE128			111

// HRI POSITION OF BARCODE
#define _BC_TEXT_NONE		0
#define _BC_TEXT_ABOVE		1
#define _BC_TEXT_BELOW		2

// Character Set
#define _CS_PC437			0		// (USA, Standard Europe)
#define _CS_KATAKANA		1		// Katakana
#define _CS_PC850			2		// 850 (Multilingual)
#define _CS_PC860			3		// 860 (Portuguese)
#define _CS_PC863			4		// 863 (Canadian-French)
#define _CS_PC865			5		// 865 (Nordic)
#define _CS_WPC1252			16		// 1252 (Latin I)
#define _CS_PC866			17		// 866 (Cyrillic #2)
#define _CS_PC852			18		// 852 (Latin 2)
#define _CS_PC858			19		// 858 (Euro)
#define _CS_PC862			21		// 862 (Hebrew DOS code)
#define _CS_PC864			22		// NOT Supported / 864 (Arabic)
#define _CS_THAI42			23		// THAI42
#define _CS_WPC1253			24		// 1253 (Greek)
#define _CS_WPC1254			25		// 1254 (Turkish)
#define _CS_WPC1257			26		// 1257 (Baltic)
#define _CS_FARSI			27		// NOT Supported / FARSI
#define _CS_WPC1251			28		// 1251 (Cyrillic)
#define _CS_PC737			29		// 737 (Greek)
#define _CS_PC775			30		// 775 (Baltic)
#define _CS_THAI14			31		// THAI14
#define _CS_WPC1255			33		// 1255 (Hebrew New Code)
#define _CS_THAI11			34		// THAI11
#define _CS_THAI18			35		// THAI18
#define _CS_PC855			36		// 855 (Cyrillic)
#define _CS_PC857			37		// 857 (Turkish)
#define _CS_PC928			38		// 928 (Greek)
#define _CS_THAI16			39		// THAI16
#define _CS_WPC1256			40		// NOT Supported / 1256 (Arabic)
#define _CS_PC1258			41		// 1258 (Vietnam)
#define _CS_KHMER			42		// NOT Supported / KHMER(Cambodia)
#define _CS_PC1250			47		// 1250 (Czech)
#define _CS_LATIN9			48		// Latin 9
#define _CS_TCVN			49		// TCVN-3 (Vietnamese)
#define _CS_TCVN_CAPITAL	50		// TCVN-3 (Vietnamese)
#define _CS_TCVN_VISCII		51		// VISCII (Vietnamese)
#define _CS_USER			255
#define _CS_KS5601			949		// KOREAN
#define _CS_BIG5			950		// CHINESE (BIG5)
#define _CS_GB2312			936		// Simplified CHINESE (GB2312)
#define _CS_SHIFT_JIS		932		// JAPAN (Shift JIS)

//International CharacterSet
#define _ICS_USA		0
#define _ICS_FRANCE		1
#define _ICS_GERMANY	2
#define _ICS_UK			3
#define _ICS_DENMARK1	4
#define _ICS_SWEDEN		5
#define _ICS_ITALY		6
#define _ICS_SPAIN		7
#define _ICS_JAPAN		8
#define _ICS_NORWAY		9
#define _ICS_DENMARK2	10	
#define _ICS_SPAIN2		11	
#define _ICS_LATIN		12	
#define _ICS_KOREA		13	
#define _ICS_SLOVENIA   14
#define _ICS_CHINA      15

// Interface Type
#define _IF_SERIAL		0
#define _IF_PARALLEL	1
#define _IF_USB			2
#define _IF_LAN			3
#define _IF_WLAN		4
#define _IF_BLUETOOTH	5